package com.uoc.taller.adapter.mailsender;

import com.uoc.taller.domain.port.EmailSender;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.ejb.Singleton;
import javax.inject.Inject;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import java.io.File;
import java.util.Properties;
import java.util.logging.Logger;

@Singleton
public class GmailEmailSender implements EmailSender {

    @Inject
    private Logger logger;

    private final Session session;
    private static Properties props = new Properties();

    static {
        props.put("mail.smtp.host", "smtp.gmail.com");
        props.put("mail.smtp.socketFactory.port", "465");
        props.put("mail.smtp.socketFactory.class",
                "javax.net.ssl.SSLSocketFactory");
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.port", "465");
    }

    public GmailEmailSender() {
        session = Session.getDefaultInstance(props,
                new javax.mail.Authenticator() {
                    protected PasswordAuthentication getPasswordAuthentication() {
                        return new PasswordAuthentication("tfm.uoc.taller", "sandacio_41");
                    }
                });

    }

    public boolean sendEmail(String to, String subject, String body, File attachment) {
        try {

            Message message = new MimeMessage(session);
            message.setFrom(new InternetAddress("tfm.uoc.taller@gmail.com"));
            message.setRecipients(Message.RecipientType.TO,
                    InternetAddress.parse(to));
            message.setSubject(subject);

            BodyPart messageBodyPart = new MimeBodyPart();
            messageBodyPart.setText(body);


            Multipart multipart = new MimeMultipart();
            multipart.addBodyPart(messageBodyPart);


            if (attachment != null) {
                messageBodyPart = new MimeBodyPart();
                DataSource source = new FileDataSource(attachment);
                messageBodyPart.setDataHandler(new DataHandler(source));
                messageBodyPart.setFileName(attachment.getName());
                multipart.addBodyPart(messageBodyPart);
            }

            message.setContent(multipart);


            Transport.send(message);

            return true;

        } catch (MessagingException e) {
            logger.info(e.getMessage());
            return false;
        }
    }

    public boolean sendEmail(String to, String subject, String body) {
        return sendEmail(to, subject, body, null);
    }
}

