package com.uoc.taller.adapter.reports.flyingsaucer;

import com.lowagie.text.DocumentException;
import org.xhtmlrenderer.pdf.ITextRenderer;

import javax.inject.Inject;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Optional;
import java.util.logging.Logger;

public class FlyingSaucerPdfGenerator {

    @Inject
    private Logger logger;

    public Optional<File> processContent(String fileName, String content) {
        File file = new File("../reports/" + fileName + ".pdf");
        file.getParentFile().mkdirs();
        try (OutputStream outputStream = new FileOutputStream(file)) {
            ITextRenderer renderer = new ITextRenderer();
            renderer.setDocumentFromString(content);
            renderer.layout();
            renderer.createPDF(outputStream);
            return Optional.of(file);
        } catch (IOException | DocumentException e) {
            logger.severe("Error generating PDF. " + e.getMessage());
            return Optional.empty();
        }
    }
}
