package com.uoc.taller.adapter.repository;

import com.uoc.taller.adapter.repository.daos.UserDAO;
import com.uoc.taller.adapter.repository.models.UserDBModel;
import com.uoc.taller.domain.entity.User;
import com.uoc.taller.domain.port.UserRepository;
import org.dozer.DozerBeanMapper;

import javax.inject.Inject;
import java.util.Optional;

public class JPAUserRepository implements UserRepository {

    private final UserDAO userDAO;
    private final DozerBeanMapper dozerBeanMapper;

    @Inject
    public JPAUserRepository(UserDAO userDAO, DozerBeanMapper dozerBeanMapper) {
        this.userDAO = userDAO;
        this.dozerBeanMapper = dozerBeanMapper;
    }

    @Override
    public Optional<User> getUser(String loginName) {
        return userDAO.getUser(loginName)
                .map(userDBModel -> dozerBeanMapper.map(userDBModel, User.class));
    }

    @Override
    public String persist(User user) {
        return userDAO.persist(dozerBeanMapper.map(user, UserDBModel.class));
    }
}
