package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.ClientDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class ClientDAO {

    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<ClientDBModel> getClient(Long id) {
        return Optional.ofNullable(entityManager.find(ClientDBModel.class, id));
    }

    public List<ClientDBModel> getAll() {
        return entityManager.createNamedQuery("Client.findAll", ClientDBModel.class)
                .getResultList();
    }

    public Long persist(ClientDBModel clientDBModel) {
        entityManager.persist(clientDBModel);
        return clientDBModel.getId();
    }

    public ClientDBModel update(ClientDBModel clientDBModel) {
        return entityManager.merge(clientDBModel);
    }
}
