package com.uoc.taller.adapter.repository.daos;


import com.uoc.taller.adapter.repository.models.DocumentItemDBModel;
import com.uoc.taller.adapter.repository.models.VehicleDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import java.util.List;

public class DocumentItemDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public List<DocumentItemDBModel> getDocumentItemsByDocumentId(Long docId) {
        return entityManager.
                createNamedQuery("DocumentItem.findByDocId", DocumentItemDBModel.class).
                setParameter("docId", docId).
                getResultList();
    }

    public Long persist(DocumentItemDBModel documentItemDBModel) {
        entityManager.persist(documentItemDBModel);
        return documentItemDBModel.getId();
    }
}
