package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.GuardTicketDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class GuardTicketDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<GuardTicketDBModel> getGuardTicket(Long id) {
        return Optional.ofNullable(entityManager.find(GuardTicketDBModel.class, id));
    }

    public List<GuardTicketDBModel> getGuardTicketsByPlate(String plate) {
        return entityManager.
                createNamedQuery("GuardTicket.findByPlate", GuardTicketDBModel.class).
                setParameter("plate", plate).
                getResultList();
    }

    public Long persist(GuardTicketDBModel guardTicketDBModel) {
        entityManager.persist(guardTicketDBModel);
        return guardTicketDBModel.getId();
    }
}
