package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.InvoiceDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class InvoiceDAO {

    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<InvoiceDBModel> getInvoice(Long id) {
        return Optional.ofNullable(entityManager.find(InvoiceDBModel.class, id));
    }

    public List<InvoiceDBModel> getInvoicesByPlate(String plate) {
        return entityManager.
                createNamedQuery("Invoice.findByPlate", InvoiceDBModel.class).
                setParameter("plate", plate).
                getResultList();
    }

    public Long persist(InvoiceDBModel invoiceDBModel) {
        entityManager.persist(invoiceDBModel);
        return invoiceDBModel.getId();
    }
}
