package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.ProductDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class ProductDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<ProductDBModel> getProduct(Long id) {
        return Optional.ofNullable(entityManager.find(ProductDBModel.class, id));
    }

    public List<ProductDBModel> getAll() {
        return entityManager.createNamedQuery("Product.findAll", ProductDBModel.class)
                .getResultList();
    }

    public Long persist(ProductDBModel productDBModel) {
        entityManager.persist(productDBModel);
        return productDBModel.getId();
    }

    public ProductDBModel update(ProductDBModel productDBModel) {
        return entityManager.merge(productDBModel);
    }

    public List<ProductDBModel> getByDesc(String desc) {
        return entityManager.createNamedQuery("Product.findByDesc", ProductDBModel.class)
                .setParameter("desc", "%" + desc + "%")
                .getResultList();
    }
}
