package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.TallerDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class TallerDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<TallerDBModel> getTaller(Long id) {
        return Optional.ofNullable(entityManager.find(TallerDBModel.class, id));
    }

    public Long persist(TallerDBModel tallerDBModel) {
        entityManager.persist(tallerDBModel);
        return tallerDBModel.getId();
    }

    public TallerDBModel update(TallerDBModel tallerDBModel) {
        return entityManager.merge(tallerDBModel);
    }

    public List<TallerDBModel> getAll() {
        return entityManager.createNamedQuery("Taller.findAll", TallerDBModel.class)
                .getResultList();
    }
}
