package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.UserDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.Optional;

public class UserDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<UserDBModel> getUser(String loginName) {
        return Optional.ofNullable(entityManager.find(UserDBModel.class, loginName));
    }

    public String persist(UserDBModel userDBModel) {
        entityManager.persist(userDBModel);
        return userDBModel.getLoginName();
    }
}
