package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.VehicleDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class VehicleDAO {

    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<VehicleDBModel> getVehicle(String plate) {
        return Optional.ofNullable(entityManager.find(VehicleDBModel.class, plate));
    }

    public List<VehicleDBModel> getAll() {
        return entityManager.createNamedQuery("Vehicle.findAll", VehicleDBModel.class)
                .getResultList();
    }

    public String persist(VehicleDBModel vehicleDBModel) {
        entityManager.persist(vehicleDBModel);
        return vehicleDBModel.getPlate();
    }

    public List<VehicleDBModel> getByClientId(Long id) {
        return entityManager.createNamedQuery("Vehicle.byClient", VehicleDBModel.class)
                .setParameter("id", id)
                .getResultList();
    }

    public VehicleDBModel update(VehicleDBModel vehicleDBModel) {
        return entityManager.merge(vehicleDBModel);
    }
}
