package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.WorkOrderDBModel;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.List;
import java.util.Optional;

public class WorkOrderDAO {
    @PersistenceContext(unitName = "taller")
    private EntityManager entityManager;

    public void setEntityManager(EntityManager entityManager) {
        this.entityManager = entityManager;
    }

    public Optional<WorkOrderDBModel> getWorkOrder(Long id) {
        return Optional.ofNullable(entityManager.find(WorkOrderDBModel.class, id));
    }

    public List<WorkOrderDBModel> getWorkOrdersByPlate(String plate) {
        return entityManager.
                createNamedQuery("WorkOrder.findByPlate", WorkOrderDBModel.class).
                setParameter("plate", plate).
                getResultList();
    }

    public Long persist(WorkOrderDBModel workOrderDBModel) {
        entityManager.persist(workOrderDBModel);
        return workOrderDBModel.getId();
    }
}
