package com.uoc.taller.adapter.repository.models;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import java.util.Date;
import java.util.Objects;
import java.util.StringJoiner;

@Entity
@NamedQuery(name="Client.findAll", query="SELECT c FROM ClientDBModel c")
public class ClientDBModel {
    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    private String taxName;
    private String name;
    private String surname;
    private String nif;
    private Date birthday;
    private String address;
    private String postalCode;
    private String city;
    private String province;
    private String country;
    private String telephone;
    private String email;


    public ClientDBModel() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTaxName() {
        return taxName;
    }

    public void setTaxName(String taxName) {
        this.taxName = taxName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public String getNif() {
        return nif;
    }

    public void setNif(String nif) {
        this.nif = nif;
    }

    public Date getBirthday() {
        return birthday;
    }

    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getPostalCode() {
        return postalCode;
    }

    public void setPostalCode(String postalCode) {
        this.postalCode = postalCode;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ClientDBModel that = (ClientDBModel) o;
        return getId().equals(that.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", ClientDBModel.class.getSimpleName() + "[", "]")
                .add("id=" + id)
                .add("taxName='" + taxName + "'")
                .add("name='" + name + "'")
                .add("surname='" + surname + "'")
                .add("nif='" + nif + "'")
                .add("birthday=" + birthday)
                .add("address='" + address + "'")
                .add("postalCode='" + postalCode + "'")
                .add("city='" + city + "'")
                .add("province='" + province + "'")
                .add("country='" + country + "'")
                .add("telephone='" + telephone + "'")
                .add("email='" + email + "'")
                .toString();
    }
}
