package com.uoc.taller.adapter.repository.models;


import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;
import java.util.Date;
import java.util.Objects;
import java.util.StringJoiner;

@MappedSuperclass
public abstract class DocumentDBModel {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private Date dateOfIssue;
    private Date expectedDate;
    private String userNif;
    private String userFiscalName;
    private String userAddress;
    private String userPostalCode;
    private String userCity;
    private String userTelephone;
    private String userMail;
    private String userProvince;
    private String userCountry;
    private String observations;
    private Integer numberKilometers;

    @ManyToOne
    @JoinColumn(nullable = false)
    private VehicleDBModel vehicle;

    @ManyToOne
    @JoinColumn(nullable = false)
    private TallerDBModel taller;

    public DocumentDBModel() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public VehicleDBModel getVehicle() {
        return vehicle;
    }

    public void setVehicle(VehicleDBModel vehicleDBModel) {
        this.vehicle = vehicleDBModel;
    }

    public String getUserFiscalName() {
        return userFiscalName;
    }

    public void setUserFiscalName(String userFiscalName) {
        this.userFiscalName = userFiscalName;
    }

    public String getUserTelephone() {
        return userTelephone;
    }

    public void setUserTelephone(String userTelephone) {
        this.userTelephone = userTelephone;
    }

    public String getUserMail() {
        return userMail;
    }

    public void setUserMail(String userMail) {
        this.userMail = userMail;
    }

    public Date getDateOfIssue() {
        return dateOfIssue;
    }

    public void setDateOfIssue(Date dateOfIssue) {
        this.dateOfIssue = dateOfIssue;
    }

    public Date getExpectedDate() {
        return expectedDate;
    }

    public void setExpectedDate(Date expectedDate) {
        this.expectedDate = expectedDate;
    }

    public TallerDBModel getTaller() {
        return taller;
    }

    public void setTaller(TallerDBModel taller) {
        this.taller = taller;
    }

    public String getUserNif() {
        return userNif;
    }

    public void setUserNif(String userNif) {
        this.userNif = userNif;
    }

    public String getUserAddress() {
        return userAddress;
    }

    public void setUserAddress(String userAddress) {
        this.userAddress = userAddress;
    }

    public String getUserPostalCode() {
        return userPostalCode;
    }

    public void setUserPostalCode(String userPostalCode) {
        this.userPostalCode = userPostalCode;
    }

    public String getUserCity() {
        return userCity;
    }

    public void setUserCity(String userCity) {
        this.userCity = userCity;
    }

    public String getUserProvince() {
        return userProvince;
    }

    public void setUserProvince(String userProvince) {
        this.userProvince = userProvince;
    }

    public String getUserCountry() {
        return userCountry;
    }

    public void setUserCountry(String userCountry) {
        this.userCountry = userCountry;
    }

    public String getObservations() {
        return observations;
    }

    public void setObservations(String observations) {
        this.observations = observations;
    }

    public Integer getNumberKilometers() {
        return numberKilometers;
    }

    public void setNumberKilometers(Integer numberKilometers) {
        this.numberKilometers = numberKilometers;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        WorkOrderDBModel that = (WorkOrderDBModel) o;
        return getId().equals(that.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", DocumentDBModel.class.getSimpleName() + "[", "]")
                .add("id=" + id)
                .add("dateOfIssue=" + dateOfIssue)
                .add("expectedDate=" + expectedDate)
                .add("userNif='" + userNif + "'")
                .add("userFiscalName='" + userFiscalName + "'")
                .add("userAddress='" + userAddress + "'")
                .add("userPostalCode='" + userPostalCode + "'")
                .add("userCity='" + userCity + "'")
                .add("userTelephone='" + userTelephone + "'")
                .add("userMail='" + userMail + "'")
                .add("userProvince='" + userProvince + "'")
                .add("userCountry='" + userCountry + "'")
                .add("observations='" + observations + "'")
                .add("numberKilometers=" + numberKilometers)
                .add("vehicle=" + vehicle)
                .add("taller=" + taller)
                .toString();
    }
}
