package com.uoc.taller.adapter.repository.models;


import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.OneToOne;
import java.util.Objects;
import java.util.StringJoiner;

@Entity
@NamedQuery(name="DocumentItem.findByDocId", query="select a from DocumentItemDBModel a where a.id=:docId")
public class DocumentItemDBModel {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @OneToOne
    private ProductDBModel product;
    private Float productPrice;
    private Float taxPercentage;
    private Float discountPercentage;
    private Integer quantity;

    public DocumentItemDBModel() {
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public ProductDBModel getProduct() {
        return product;
    }

    public void setProduct(ProductDBModel product) {
        this.product = product;
    }

    public Float getProductPrice() {
        return productPrice;
    }

    public void setProductPrice(Float productPrice) {
        this.productPrice = productPrice;
    }

    public Float getTaxPercentage() {
        return taxPercentage;
    }

    public void setTaxPercentage(Float taxPercentage) {
        this.taxPercentage = taxPercentage;
    }

    public Float getDiscountPercentage() {
        return discountPercentage;
    }

    public void setDiscountPercentage(Float discountPercentage) {
        this.discountPercentage = discountPercentage;
    }

    public Integer getQuantity() {
        return quantity;
    }

    public void setQuantity(Integer quantity) {
        this.quantity = quantity;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        DocumentItemDBModel that = (DocumentItemDBModel) o;
        return getId().equals(that.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getId());
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", DocumentItemDBModel.class.getSimpleName() + "[", "]")
                .add("id=" + id)
                .add("productPrice=" + productPrice)
                .add("taxPercentage=" + taxPercentage)
                .add("discountPercentage=" + discountPercentage)
                .add("quantity=" + quantity)
                .toString();
    }
}
