package com.uoc.taller.adapter.repository.models;

import com.uoc.taller.domain.entity.PaymentMethod;
import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import java.util.List;
import java.util.StringJoiner;

@Entity
@NamedQuery(name = "Invoice.findByPlate", query = "SELECT inv FROM InvoiceDBModel inv JOIN inv.vehicle v where v.plate=:plate")
public class InvoiceDBModel extends DocumentDBModel {

    @Enumerated(EnumType.STRING)
    private PaymentMethod paymentMethod;

    @OneToMany(cascade = {CascadeType.ALL})
    @LazyCollection(LazyCollectionOption.FALSE)
    private List<DocumentItemDBModel> documentItemDBModel;

    public InvoiceDBModel() {
    }

    public PaymentMethod getPaymentMethod() {
        return paymentMethod;
    }

    public void setPaymentMethod(PaymentMethod paymentMethod) {
        this.paymentMethod = paymentMethod;
    }

    public List<DocumentItemDBModel> getDocumentItemDBModel() {
        return documentItemDBModel;
    }

    public void setDocumentItemDBModel(List<DocumentItemDBModel> documentItemDBModel) {
        this.documentItemDBModel = documentItemDBModel;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        InvoiceDBModel that = (InvoiceDBModel) o;
        return getId().equals(that.getId());
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", InvoiceDBModel.class.getSimpleName() + "[", "]")
                .add(super.toString())
                .add("paymentMethod=" + paymentMethod)
                .toString();
    }
}
