package com.uoc.taller.adapter.repository.models;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import java.util.Objects;
import java.util.StringJoiner;

@Entity
@NamedQueries({
        @NamedQuery(name = "Vehicle.findAll", query = "SELECT c FROM VehicleDBModel c"),
        @NamedQuery(name = "Vehicle.byClient", query = "select v from VehicleDBModel v where v.client.id = :id")
})
public class VehicleDBModel {
    @Id
    private String plate;
    private String chassisNumber;
    private String brand;
    private String model;
    private String year;
    private String color;

    @ManyToOne
    @JoinColumn(nullable = false)
    public ClientDBModel client;

    public VehicleDBModel() {

    }

    public String getPlate() {
        return plate;
    }

    public void setPlate(String plate) {
        this.plate = plate;
    }

    public String getChassisNumber() {
        return chassisNumber;
    }

    public void setChassisNumber(String chassisNumber) {
        this.chassisNumber = chassisNumber;
    }

    public String getBrand() {
        return brand;
    }

    public void setBrand(String brand) {
        this.brand = brand;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getYear() {
        return year;
    }

    public void setYear(String year) {
        this.year = year;
    }

    public String getColor() {
        return color;
    }

    public void setColor(String color) {
        this.color = color;
    }


    public ClientDBModel getClient() {
        return client;
    }

    public void setClient(ClientDBModel client) {
        this.client = client;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        VehicleDBModel that = (VehicleDBModel) o;
        return getPlate().equals(that.getPlate());
    }

    @Override
    public int hashCode() {
        return Objects.hash(getPlate());
    }

    @Override
    public String toString() {
        return new StringJoiner(", ", VehicleDBModel.class.getSimpleName() + "[", "]")
                .add("plate='" + plate + "'")
                .add("chassisNumber='" + chassisNumber + "'")
                .add("brand='" + brand + "'")
                .add("model='" + model + "'")
                .add("year='" + year + "'")
                .add("color='" + color + "'")
                .toString();
    }
}
