package com.uoc.taller.adapter.repository.models;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import java.util.Date;
import java.util.List;

@Entity
@NamedQuery(name = "WorkOrder.findByPlate", query = "select a from WorkOrderDBModel a JOIN a.vehicle v where v.plate=:plate")
public class WorkOrderDBModel extends DocumentDBModel {


    @OneToMany(cascade = {CascadeType.ALL}, fetch = FetchType.EAGER)
    private List<DocumentItemDBModel> documentItemDBModel;
    private Date endValidity;

    public WorkOrderDBModel() {
    }

    public List<DocumentItemDBModel> getDocumentItemDBModel() {
        return documentItemDBModel;
    }

    public void setDocumentItemDBModel(List<DocumentItemDBModel> documentItemDBModel) {
        this.documentItemDBModel = documentItemDBModel;
    }

    public Date getEndValidity() {
        return endValidity;
    }

    public void setEndValidity(Date endValidity) {
        this.endValidity = endValidity;
    }
}
