package com.uoc.taller.adapter.rest;

import com.uoc.taller.usecase.PlateRecognition;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.json.Json;
import javax.ws.rs.Consumes;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.core.Response;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Logger;

@Stateless
@Path("/plates")
public class PlateRecognitionResource {

    private static final String MEDIA_TYPE_JPG = "image/jpeg";

    @Inject
    private Logger logger;

    @Inject
    private PlateRecognition plateRecognition;


    @POST
    @Path("recognition")
    @Consumes(MEDIA_TYPE_JPG)
    public Response uploadImage(InputStream inputStream, @HeaderParam("Content-Type") String fileType, @HeaderParam("Content-Length") long fileSize) {

        logger.info("Content-type: " + fileType);
        logger.info("Size: " + fileSize + " Kb");
        logger.info("Size: " + fileSize / 1000000D + "  Mb");
        try {
            return Response.ok(Json.createObjectBuilder()
                    .add("plate", plateRecognition.recognize(inputStream))
                    .build())
                    .build();
        } catch (IOException e) {
            return Response.serverError().build();
        }
    }

}
