package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.User;

import javax.inject.Inject;
import java.util.Optional;

public class AuthenticateUser {

    @Inject
    private ValidateUserCredentials validateUserCredentials;

    @Inject
    private GetUser getUser;

    public Optional<User> validate(User user) {
        if(validateUserCredentials.validate(user.getLoginName(), user.getPassword())) {
            return getUser.get(user.getLoginName());
        }
        return Optional.empty();
    }
}
