package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.DocumentItem;
import com.uoc.taller.domain.entity.Invoice;
import com.uoc.taller.domain.port.InvoiceRepository;

import javax.inject.Inject;

public class CreateInvoice {

    private final InvoiceRepository invoiceRepository;

    @Inject
    private UpdateProduct updateProduct;

    @Inject
    public CreateInvoice(InvoiceRepository invoiceRepository) {
        this.invoiceRepository = invoiceRepository;
    }

    public Long create(Invoice invoice) {
        Long idInvoice = invoiceRepository.persist(invoice);
        //Time to adapt available stock
        for (DocumentItem doc : invoice.getDocumentItems()) {
            updateProduct.updateAvailableStock(doc.getProduct(), doc.getQuantity());
        }
        return idInvoice;
    }
}
