package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.User;
import com.uoc.taller.domain.entity.exceptions.EncryptionException;
import com.uoc.taller.domain.port.EncryptionService;
import com.uoc.taller.domain.port.UserRepository;

import javax.inject.Inject;

public class CreateUser {

    private final UserRepository userRepository;
    private final EncryptionService encryptionService;


    @Inject
    public CreateUser(UserRepository userRepository, EncryptionService encryptionService) {
        this.userRepository = userRepository;
        this.encryptionService = encryptionService;
    }

    public String create(User user) throws EncryptionException {
        user.setPassword(encryptionService.encrypt(user.getPassword()));
        return userRepository.persist(user);
    }
}
