package com.uoc.taller.usecase;

import com.uoc.taller.adapter.reports.GuardTicketReportGenerator;
import com.uoc.taller.domain.port.GuardTicketRepository;

import javax.inject.Inject;
import java.io.File;
import java.util.Optional;

public class GenerateGuardTicketHtml {

    @Inject
    private GuardTicketReportGenerator guardTicketReportGenerator;

    @Inject
    private GuardTicketRepository guardTicketRepository;


    public Optional<File> generateGuardTicket(Long id) {
        return guardTicketRepository.getGuardTicket(id)
                .map(guardTicket -> guardTicketReportGenerator.generateHTMLFile(guardTicketReportGenerator.generateHtml(guardTicket), guardTicket.getId().toString()))
                .flatMap(file -> file);
    }

}
