package com.uoc.taller.usecase;

import com.uoc.taller.adapter.reports.GuardTicketReportGenerator;
import com.uoc.taller.domain.port.GuardTicketRepository;

import javax.inject.Inject;
import java.io.File;
import java.util.Optional;

public class GenerateGuardTicketPdf {

    private final static String PREFIX = "RESGUARDO";

    @Inject
    private GuardTicketRepository guardTicketRepository;

    @Inject
    private GuardTicketReportGenerator guardTicketReportGenerator;

    public Optional<File> generateGuardTicket(Long id) {
        return guardTicketRepository.getGuardTicket(id)
                .map(guardTicket -> guardTicketReportGenerator.generatePDF(guardTicket, PREFIX + guardTicket.getId().toString()))
                .flatMap(file -> file);
    }
}
