package com.uoc.taller.usecase;

import com.uoc.taller.adapter.reports.InvoiceReportGenerator;
import com.uoc.taller.domain.port.InvoiceRepository;

import javax.inject.Inject;
import java.io.File;
import java.util.Optional;

public class GenerateInvoiceHtml {

    @Inject
    private InvoiceReportGenerator invoiceReportGenerator;

    @Inject
    private InvoiceRepository invoiceRepository;


    public Optional<File> generateInvoice(Long id) {
        return invoiceRepository.getInvoice(id)
                .map(invoice -> invoiceReportGenerator.generateHTMLFile(invoiceReportGenerator.generateHtml(invoice), invoice.getId().toString()))
                .flatMap(file -> file);
    }

}
