package com.uoc.taller.usecase;

import com.uoc.taller.adapter.reports.InvoiceReportGenerator;
import com.uoc.taller.domain.port.InvoiceRepository;

import javax.inject.Inject;
import java.io.File;
import java.util.Optional;

public class GenerateInvoicePdf {

    private final static String PREFIX = "FACTURA";

    @Inject
    private InvoiceRepository invoiceRepository;

    @Inject
    private InvoiceReportGenerator invoiceReportGenerator;

    public Optional<File> generateInvoice(Long id) {
        return invoiceRepository.getInvoice(id)
                .map(invoice -> invoiceReportGenerator.generatePDF(invoice, PREFIX + invoice.getId().toString()))
                .flatMap(file -> file);
    }
}
