package com.uoc.taller.usecase;

import com.uoc.taller.adapter.reports.WorkOrderReportGenerator;
import com.uoc.taller.domain.port.WorkOrderRepository;

import javax.inject.Inject;
import java.io.File;
import java.util.Optional;

public class GenerateWorkOrderPdf {

    private final static String PREFIX = "ORDEN";

    @Inject
    private WorkOrderReportGenerator workOrderReportGenerator;

    @Inject
    private WorkOrderRepository workOrderRepository;


    public Optional<File> generateWorkOrder(Long id) {
        return workOrderRepository.getWorkOrder(id)
                .map(workOrder -> workOrderReportGenerator.generatePDF(workOrder, PREFIX+ workOrder.getId().toString()))
                .flatMap(file -> file);
    }

}
