package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.Flow;
import com.uoc.taller.domain.entity.FlowStatus;
import com.uoc.taller.domain.port.FlowRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetFlow {

    private final FlowRepository flowRepository;

    @Inject
    public GetFlow(FlowRepository flowRepository) {
        this.flowRepository = flowRepository;
    }

    public Optional<Flow> get(Long id) {
        return flowRepository.getFlow(id);
    }

    public List<Flow> getByStatus(FlowStatus flowStatus, Long tallerId) {
        if(tallerId != null && flowStatus != null) {
            return flowRepository.getByTallerIdAndStatus(tallerId, flowStatus);
        }
        return flowRepository.getByStatus(flowStatus);
    }

    public List<Flow> getByPlate(String plate) {
        return flowRepository.getByPlate(plate);
    }
}
