package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.GuardTicket;
import com.uoc.taller.domain.port.GuardTicketRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetGuardTicket {

    private final GuardTicketRepository guardTicketRepository;

    @Inject
    public GetGuardTicket(GuardTicketRepository guardTicketRepository) {
        this.guardTicketRepository = guardTicketRepository;
    }

    public Optional<GuardTicket> get(Long id) {
        return guardTicketRepository.getGuardTicket(id);
    }

    public List<GuardTicket> getAllByPlate(String plate){
        return guardTicketRepository.getAllGuardTicketsByPlate(plate);
    }
}
