package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.Invoice;
import com.uoc.taller.domain.port.InvoiceRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetInvoice {

    private final InvoiceRepository invoiceRepository;

    @Inject
    public GetInvoice(InvoiceRepository invoiceRepository) {
        this.invoiceRepository = invoiceRepository;
    }

    public List<Invoice> getAll(String plate){
        return invoiceRepository.getAllInvoicesByPlate(plate);
    }

    public Optional<Invoice> get(long id){
        return invoiceRepository.getInvoice(id);
    }
}
