package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.Product;
import com.uoc.taller.domain.port.ProductRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetProduct {

    private final ProductRepository productRepository;

    @Inject
    public GetProduct(ProductRepository productRepository) {
        this.productRepository = productRepository;
    }

    public Optional<Product> get(Long id){
        return productRepository.getProduct(id);
    }
    public List<Product> getAll(){
        return productRepository.getAllProducts();
    }

    public List<Product> getByDescription(String desc) {
        return productRepository.getByDesc(desc);
    }
}
