package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.Vehicle;
import com.uoc.taller.domain.port.VehicleRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetVehicle {

    private final VehicleRepository vehicleRepository;

    @Inject
    public GetVehicle(VehicleRepository vehicleRepository) {
        this.vehicleRepository = vehicleRepository;
    }

    public Optional<Vehicle> get(String plate) {
        return vehicleRepository.getVehicle(plate);
    }

    public List<Vehicle> getAll() {
        return vehicleRepository.getAllVehicles();
    }

    public List<Vehicle> getByClientId(Long id) {
        return vehicleRepository.getByClientId(id);
    }
}
