package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.WorkOrder;
import com.uoc.taller.domain.port.WorkOrderRepository;

import javax.inject.Inject;
import java.util.List;
import java.util.Optional;

public class GetWorkOrder {

    private final WorkOrderRepository workOrderRepository;

    @Inject
    public GetWorkOrder(WorkOrderRepository workOrderRepository) {
        this.workOrderRepository = workOrderRepository;
    }

    public Optional<WorkOrder> get(Long id) {
        return workOrderRepository.getWorkOrder(id);
    }

    public List<WorkOrder> getAll(String plate) {
        return workOrderRepository.getAllWorkOrdersByPlate(plate);
    }

}
