package com.uoc.taller.usecase;

import com.uoc.taller.domain.entity.Client;
import com.uoc.taller.domain.entity.Communication;
import com.uoc.taller.domain.port.EmailSender;

import javax.inject.Inject;

public class SendCustomerNotification {

    @Inject
    private GetClient getClient;
    @Inject
    private EmailSender emailSender;

    public boolean send(Long clientId, Communication communication) {
        return getClient.get(clientId)
                .map(Client::getEmail)
                .map(email -> emailSender.sendEmail(email, communication.getSubject(), communication.getBody()))
                .orElse(false);
    }
}
