package com.uoc.taller.adapter.encription;

import com.uoc.taller.adapter.encryption.HexConverter;
import com.uoc.taller.adapter.encryption.PBKDF2EncryptionService;
import com.uoc.taller.domain.entity.exceptions.EncryptionException;
import com.uoc.taller.domain.port.EncryptionService;
import org.junit.Test;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

public class PBKDF2EncryptionServiceTest {

    EncryptionService encryptionService = new PBKDF2EncryptionService(new HexConverter());

    @Test
    public void validateValidPassword() {
        try {
            String hashed = encryptionService.encrypt("test");
            assertTrue(encryptionService.validate(hashed, "test"));
        } catch (EncryptionException e) {
            fail("Unexpected exception: " + e.getMessage());
        }
    }

}
