package com.uoc.taller.adapter.reports;

import com.uoc.taller.adapter.reports.flyingsaucer.FlyingSaucerPdfGenerator;
import com.uoc.taller.adapter.reports.labels.LabelManager;
import com.uoc.taller.adapter.reports.thymeleaf.HtmlThymeleafTemplateGenerator;
import com.uoc.taller.domain.entity.DocumentItem;
import com.uoc.taller.domain.entity.Invoice;
import com.uoc.taller.domain.entity.PaymentMethod;
import com.uoc.taller.domain.entity.Product;
import com.uoc.taller.domain.entity.Taller;
import com.uoc.taller.domain.entity.Vehicle;
import org.junit.Test;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class InvoiceReportGeneratorTest {

    @Test
    public void test() {
        Invoice invoice = new Invoice();
        invoice.setTaller(new Taller());
        invoice.setId(43254L);
        invoice.setDateOfIssue(new Date());
        invoice.setExpectedDate(new Date());
        invoice.setUserFiscalName("Pepe");
        invoice.setNumberKilometers(4541);
        invoice.setObservations("Observaciones varias de la factura");
        invoice.setVehicle(new Vehicle());
        invoice.setTaller(new Taller());
        invoice.setUserAddress("address");
        invoice.setUserCity("city");
        invoice.setUserCountry("España");
        invoice.setUserProvince("Asturias");
        invoice.setUserPostalCode("330");
        invoice.setPaymentMethod(PaymentMethod.BIZUM);
        invoice.setDocumentItems(generateDocumentItemDBModelList());

        InvoiceReportGenerator invoiceReportGenerator = new InvoiceReportGenerator(new HtmlThymeleafTemplateGenerator(),
                new FlyingSaucerPdfGenerator(),
                new LabelManager());
        invoiceReportGenerator.generatePDF(invoice, invoice.getId().toString());
    }

    public List<DocumentItem> generateDocumentItemDBModelList() {
        List<Product> productListIds = new ArrayList<>();
        List<DocumentItem> documentItemList = new ArrayList<>();
        Product prod;
        for (int i = 0; i < 5; i++) {
            prod= new Product();
            prod.setCode("CODIGO"+i);
            prod.setDescription("DESC_CODIGO"+i);
            prod.setId((long) i);
            productListIds.add(prod);
        }
        for (int i = 0; i < 5; i++) {
            documentItemList.add(funcCreateDocumentItem(productListIds.get(i)));
        }
        return documentItemList;
    }

    public DocumentItem funcCreateDocumentItem(Product product) {
        DocumentItem documentItem = new DocumentItem();
        documentItem.setDiscountPercentage(5f);
        documentItem.setProductPrice(30f);
        documentItem.setQuantity(4);
        documentItem.setTaxPercentage(10f);
        documentItem.setProduct(product);
        return documentItem;
    }
}
