package com.uoc.taller.adapter.repository.daos;

import com.uoc.taller.adapter.repository.models.ClientDBModel;
import com.uoc.taller.adapter.repository.models.DocumentItemDBModel;
import com.uoc.taller.adapter.repository.models.InvoiceDBModel;
import com.uoc.taller.adapter.repository.models.TallerDBModel;
import com.uoc.taller.adapter.repository.models.VehicleDBModel;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.Arrays;

public class InvoiceDAOTest extends AbstractDAOTest {

    private InvoiceDAO invoiceDAO;
    private VehicleDAO vehicleDAO;
    private ClientDAO clientDAO;
    private TallerDAO tallerDAO;


    @Before
    public void assigningEntityManager() {
        invoiceDAO = new InvoiceDAO();
        invoiceDAO.setEntityManager(em);
        vehicleDAO = new VehicleDAO();
        vehicleDAO.setEntityManager(em);
        clientDAO = new ClientDAO();
        clientDAO.setEntityManager(em);
        tallerDAO = new TallerDAO();
        tallerDAO.setEntityManager(em);
    }

    @Test
    public void getInvoiceByIdNotFound() {
        Assert.assertFalse("Client found and it shouldn't", invoiceDAO.getInvoice(1L).isPresent());
    }

    @Test
    public void persistInvoice() {
        InvoiceDBModel invoiceDBModel = new InvoiceDBModel();
        DocumentItemDBModel doc1 = new DocumentItemDBModel();
        doc1.setDiscountPercentage(4.3f);
        DocumentItemDBModel doc2 = new DocumentItemDBModel();
        doc2.setDiscountPercentage(4.3f);
        invoiceDBModel.setDocumentItemDBModel(Arrays.asList(doc1, doc2));
        ClientDBModel clientDBModel = new ClientDBModel();
        clientDBModel.setName("Pepe");
        clientDAO.persist(clientDBModel);
        VehicleDBModel vehicleDBModel = new VehicleDBModel();
        vehicleDBModel.setPlate("1231FGJ");
        vehicleDBModel.setClient(clientDBModel);
        vehicleDAO.persist(vehicleDBModel);
        invoiceDBModel.setVehicle(vehicleDBModel);
        TallerDBModel tallerDBModel = new TallerDBModel();
        tallerDBModel.setNif("1231234G");
        tallerDAO.persist(tallerDBModel);
        invoiceDBModel.setTaller(tallerDBModel);
        Long id = invoiceDAO.persist(invoiceDBModel);
        invoiceDAO.getInvoice(id);
    }

}
