import { Component, OnInit } from '@angular/core';
import { ClientService } from '../../services/clients/client.service';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Client } from '../../services/clients/client';
import { PROVINCES } from '../../enums/provinces';

@Component({
  selector: 'app-client-detail',
  templateUrl: './client-detail.component.html',
  styleUrls: ['./client-detail.component.scss']
})
export class ClientDetailComponent implements OnInit {
  client: Client;
  labelBirthday: string;
  idBirthday: string;

  provinces = PROVINCES;

  constructor(
    private route: ActivatedRoute,
    private clientService: ClientService,
    private location: Location) { }

  ngOnInit(): void {
    this.getClient();
    this.labelBirthday = "Fecha de nacimiento";
    this.idBirthday = "birthday";
  }

  getClient(): void {
    const id = +this.route.snapshot.paramMap.get('id');
    this.clientService.getClient(id)
      .subscribe(client => this.client = client);
  }

  onSubmit() {
    this.clientService.updateClient(this.client).subscribe(client => this.client = client);
    this. goBack();
  }

  goBack(): void {
    this.location.back();
  }

  saveDate(date: number, idField: string) {
    if (idField == this.idBirthday) {
      this.client.birthday = date;
    }
    else {
      console.log("Error salvando la fecha de la factura: " + idField)
    }
  }


  // parseDate(dateString: string): Date {
  //   if (dateString) {
  //     return new Date(dateString);
  //   } else {
  //     return null;
  //   }
  // }

}
