import { Component, OnInit } from '@angular/core';
import { Location } from '@angular/common';

import { Client } from '../../services/clients/client'
import { ClientService } from '../../services/clients/client.service';
import { PROVINCES } from '../../enums/provinces';

@Component({
  selector: 'app-client-form',
  templateUrl: './client-form.component.html',
  styleUrls: ['./client-form.component.scss']
})
export class ClientFormComponent implements OnInit{

  provinces = PROVINCES;
  labelBirthday: string;
  idBirthday: string;
  model = new Client();

  constructor(
    public clientService: ClientService,
    private location: Location
  ) { }

  onSubmit() { 
    this.clientService.addClient(this.model).subscribe(client => this.model = client);
    this.goBack();
  }

  ngOnInit(): void {
    this.labelBirthday = "Fecha de nacimiento";
    this.idBirthday = "birthday";
  }

  goBack(): void {
    this.location.back();
  }

  saveDate(date: number, idField: string) {
    if (idField == this.idBirthday) {
      this.model.birthday = date;
    }
    else {
      console.log("Error salvando la fecha de la factura: " + idField)
    }
  }

}
