//Fuente original: https://codeburst.io/angular-4-custom-validation-for-template-based-forms-b7dee9be48a6

import {
    NG_VALIDATORS,
    FormControl,
    ValidatorFn,
    Validator
} from '@angular/forms';
import { Directive } from '@angular/core';
@Directive({
    selector: '[nifvalidator][ngModel]',
    providers: [
        {
            provide: NG_VALIDATORS,
            useExisting: NifValidator,
            multi: true
        }
    ]
})
export class NifValidator implements Validator {
    validator: ValidatorFn;
    constructor() {
        this.validator = this.nifValidator();
    }
    validate(c: FormControl) {
        return this.validator(c);
    }

    nifValidator(): ValidatorFn {
        return (c: FormControl) => {
            let nifRexp = /^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$/.test(c.value);
            let nieRexp = /^[XYZ]{1}[0-9]{7}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$/.test(c.value);
            if (nifRexp || nieRexp) {
                return null;
            } else {
                return {
                    nifvalidator: {
                        valid: false
                    }
                };
            }
        }
    }
}