//Fuente original: https://codeburst.io/angular-4-custom-validation-for-template-based-forms-b7dee9be48a6

import {
    NG_VALIDATORS,
    FormControl,
    ValidatorFn,
    Validator
} from '@angular/forms';
import { Directive } from '@angular/core';
@Directive({
    selector: '[selectvalidator][ngModel]',
    providers: [
        {
            provide: NG_VALIDATORS,
            useExisting: SelectValidator,
            multi: true
        }
    ]
})
export class SelectValidator implements Validator {
    validator: ValidatorFn;
    constructor() {
        this.validator = this.selectValidator();
    }
    validate(c: FormControl) {
        return this.validator(c);
    }

    selectValidator(): ValidatorFn {
        return (c: FormControl) => {
            if (c.value != -1) {
                return null;
            } else {
                return {
                    selectvalidator: {
                        valid: false
                    }
                };
            }
        }
    }
}