import {Component, OnInit} from '@angular/core';
import {SendEmailService} from '../services/send-email.service';
import {NotificationService} from '../services/notifications/notification.service';

@Component({
  selector: 'app-footer',
  templateUrl: './footer.component.html',
  styleUrls: ['./footer.component.scss']
})
export class FooterComponent implements OnInit {

  constructor(
    private sendEmailService: SendEmailService,
    private notificationService: NotificationService
  ) {
  }

  ngOnInit() {
  }

  public sendEmail() {
    this.sendEmailService.send()
      .then((confirmed) => {
        if (confirmed && confirmed.length == 2) {
          this.notificationService.sendEmailToAuthor(confirmed[0], confirmed[1])
            .subscribe(data => console.log("Email enviado"), error => console.log("Error email no enviado"));
        }
      })
      .catch(() => console.log('User dismissed the dialog (e.g., by using ESC, clicking the cross icon, or clicking outside the dialog)'));
  }

}
