import { Component, OnInit } from '@angular/core';
import { GuardTicketService } from 'src/app/services/guard-tickets/guard-ticket.service';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { GuardTicket } from 'src/app/services/guard-tickets/guard-ticket';
import { PdfReportService } from 'src/app/services/pdf-report/pdf-report.service';

@Component({
  selector: 'app-guard-ticket-preview',
  templateUrl: './guard-ticket-preview.component.html',
  styleUrls: ['./guard-ticket-preview.component.scss']
})
export class GuardTicketPreviewComponent implements OnInit {

  model: GuardTicket;

  constructor(
    private guardTicketService: GuardTicketService,
    private route: ActivatedRoute,
    private pdfReportService: PdfReportService,
    private location: Location) { }

  ngOnInit() {
    this.loadGuardTicket();
  }

  loadGuardTicket() {
    const id = +this.route.snapshot.paramMap.get('id');
    this.guardTicketService.getGuardTicket(id)
      .subscribe(guardTicket => this.model = guardTicket);
  }

  goBack(): void {
    this.location.back();
  }

  getPDF(id: number) {
    this.pdfReportService.getPDF(id, this.guardTicketService);
  }

}
