import { Component, OnInit } from '@angular/core';
import { AuthenticationService } from '../services/users/authentication.service';
import { Router } from '@angular/router';

@Component({
  selector: 'app-header',
  templateUrl: './header.component.html',
  styleUrls: ['./header.component.scss']
})
export class HeaderComponent implements OnInit {

  logged: any;

  constructor(
    private authenticationService: AuthenticationService,
    private router: Router) { }

  ngOnInit() {
    this.authenticationService.isLogged.subscribe(logged => this.logged = logged);
    if (localStorage.getItem('currentUser') == null) {
      this.logged = false;
    } else {
      this.logged = true;
    }
  }

  toggleMenu() {
    document.getElementById("burger_content").classList.toggle("collapse");
  }

  burgerMenuOptionClicked(link: string) {
    this.toggleMenu();
    this.router.navigate([link]);
  }

}
