import { Component, OnInit } from '@angular/core';
import { TallerService } from 'src/app/services/talleres/taller.service';
import { Taller } from 'src/app/services/talleres/taller';

@Component({
  selector: 'app-taller',
  templateUrl: './taller.component.html',
  styleUrls: ['./taller.component.scss']
})
export class TallerComponent implements OnInit {

  tallerList: Taller[];

  taller: Taller;

  constructor(private tallerService: TallerService) {
  }

  ngOnInit() {
    this.getTalleres(false);
  }

  getTalleres(isFromReloadButton: boolean): void {
    this.tallerService.getTalleres()
      .subscribe(talleres => {
        this.tallerList = talleres;
        if (!isFromReloadButton) {
          var currentTaller = localStorage.getItem('currentTaller');
          this.setTaller(currentTaller != null && currentTaller != 'undefined' ? JSON.parse(localStorage.getItem('currentTaller')).id : this.tallerList[0].id, false);
        }
      });
  }

  setTaller(id: string, isFromReloadButton: boolean) {
    this.tallerService.getTaller(Number(id))
      .subscribe(taller => {
        this.taller = taller;
        localStorage.setItem('currentTaller', JSON.stringify(this.taller));
        if (isFromReloadButton) {
          location.reload();
        }
      });
  }
}
