import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';

@Component({
  selector: 'app-html-date-time',
  templateUrl: './html-date-time.component.html',
  styleUrls: ['./html-date-time.component.scss']
})
export class HtmlDateTimeComponent implements OnInit {

  @Input() label: string;
  @Input() idInput: string;
  @Input() originalDate: string;

  @Output() selectedDate = new EventEmitter();

  parsedValue: string;

  change(newValue: any) {
    this.selectedDate.emit(this.formatDateTime(newValue.target.value));
  }

  constructor() { }

  ngOnInit() {
    if (this.originalDate != null) {
      let inputDate = new Date(parseInt(this.originalDate));
      this.parsedValue =
        inputDate.getFullYear() + "-" +
        ((inputDate.getMonth() + 1) < 10 ? "0" + (inputDate.getMonth() + 1) : (inputDate.getMonth() + 1)) + "-" +
        (inputDate.getDate() < 10 ? "0" + inputDate.getDate() : inputDate.getDate()) + "T" +
        (inputDate.getHours() < 10 ? "0" + inputDate.getHours() : inputDate.getHours()) + ":" +
        (inputDate.getMinutes() < 10 ? "0" + inputDate.getMinutes() : inputDate.getMinutes());
        this.selectedDate.emit(this.formatDateTime(this.parsedValue));
    }
  }

  formatDateTime(stringDateTime: any): number {
    stringDateTime = stringDateTime.replace("T", "-");
    stringDateTime = stringDateTime.replace(":", "-");
    let str = stringDateTime.split('-');
    let year = Number(str[0]);
    let month = Number(str[1]) - 1;
    let date = Number(str[2]);
    let hour = Number(str[3]);
    let minute = Number(str[4]);

    return new Date(year, month, date, hour, minute).getTime();
  }
}
