import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';

@Component({
  selector: 'app-html-date',
  templateUrl: './html-date.component.html',
  styleUrls: ['./html-date.component.scss']
})
export class HtmlDateComponent implements OnInit {
  @Input() label: string;
  @Input() idInput: string;
  @Input() originalDate: string;

  parsedValue: string;

  @Output() selectedDate = new EventEmitter();

  change(newValue) {
    this.selectedDate.emit(this.formatDate(newValue.target.value));
  }

  constructor() { }

  ngOnInit() {
    if (this.originalDate != null) {
      let inputDate = new Date(parseInt(this.originalDate));
      this.parsedValue =
        inputDate.getFullYear() + "-" +
        (inputDate.getMonth() + 1) + "-" +
        inputDate.getDate();
        this.selectedDate.emit(this.formatDate(this.parsedValue));
    }
  }

  formatDate(date: any): number {
    let str = date.split('-');
    let year = Number(str[0]);
    let month = Number(str[1]) - 1;
    let day = Number(str[2]);

    return new Date(year, month, day).getTime();
  }

}
