import { Component, OnInit } from '@angular/core';
import { ProductService } from '../../services/products/product.service';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Product } from '../../services/products/product';

@Component({
  selector: 'app-product-detail',
  templateUrl: './product-detail.component.html',
  styleUrls: ['./product-detail.component.scss']
})
export class ProductDetailComponent implements OnInit {

  product: Product;

  productCategory = ['BRAKES', 'BRAKEFLUID', 'ELECTRONIC', 'MOTOR', 'OIL', 'TIRES', 'WORKFORCE'];

  constructor(
    private route: ActivatedRoute,
    private productService: ProductService,
    private location: Location) { }

  ngOnInit(): void {
    this.getProduct();
  }

  getProduct(): void {
    const id = +this.route.snapshot.paramMap.get('id');
    this.productService.getProduct(id)
      .subscribe(product => this.product = product);
  }

  onSubmit() {
    this.productService.updateProduct(this.product).subscribe(product =>{ 
      this.product = product;
      this.goBack();
    });
  }

  goBack(): void {
    this.location.back();
  }

}
