import { Component } from '@angular/core';
import { Location } from '@angular/common';

import { Product } from '../../services/products/product'
import { ProductService } from '../../services/products/product.service';

@Component({
  selector: 'app-product-form',
  templateUrl: './product-form.component.html',
  styleUrls: ['./product-form.component.scss']
})
export class ProductFormComponent {

  productCategory = ['BRAKEFLUID', 'ELECTRONIC', 'MOTOR', 'OIL', 'TIRES', 'WORKFORCE'];

  model = new Product();

  constructor(
    public productService: ProductService,
    private location: Location
  ) { }

  onSubmit() {
    this.productService.addProduct(this.model).subscribe(product => this.model = product);
    this.goBack();
  }

  goBack(): void {
    this.location.back();
  }

}
