import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { GenericRestService } from './generic-rest/generic-rest.service';

@Injectable({
  providedIn: 'root'
})
export class DocumentCommonService {

  constructor(
    private http: HttpClient,
    private genericRestService: GenericRestService) { }

  getPDF(idParam: any, pdfCreatorUrl: string): Observable<any> {
    var headers = this.genericRestService.getDocumentHeaders();
    return this.http.get(pdfCreatorUrl.concat('/', idParam, '/pdf'), { headers, responseType: 'blob' })
  }

  getHTML(idParam: any, pdfCreatorUrl: string): Observable<any> {
    var headers = this.genericRestService.getDocumentHeaders();
    return this.http.get(pdfCreatorUrl.concat('/', idParam, '/html'), { headers, responseType: 'text' })
  }

}