import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { UserStorage } from '../users/userStorage';

const httpHeaders = new HttpHeaders({ 'Content-Type': 'application/json;charset=UTF-8', 'accept': 'application/json' });
const imageHeaders = new HttpHeaders({'Content-Type': 'image/jpeg'});
const docHttpOptions = new HttpHeaders({ 'Content-Type': 'text/plain;charset=utf-8' });

declare var window: any;

@Injectable({
  providedIn: 'root'
})
export class GenericRestService {

  constructor() { }

  getHeaders(): {} {
    return { headers: this.includeAuthHeader(httpHeaders) };
  }

  includeAuthHeader(headers: HttpHeaders): HttpHeaders {
    let currentUser: UserStorage = JSON.parse(localStorage.getItem('currentUser'));
    if (currentUser && currentUser.authData) {
      return headers.append('Authorization', `Basic ${currentUser.authData}`);
    }
    return headers;
  }

  getDocumentHeaders(): {} {
    return this.includeAuthHeader(docHttpOptions);
  }

  getUrlPrefix() {
    return 'http://' + this.giveMeHost() + '/taller/rs';
  }

  giveMeHost() {
    return window.location.host === "localhost:4200" ? "localhost:8080" : window.location.host;
  }

  getImageHeaders() {
    return { headers: this.includeAuthHeader(imageHeaders) };
  }
}
