import { Injectable } from '@angular/core';
import { NgbModal } from '@ng-bootstrap/ng-bootstrap';
import { SendEmailComponent } from '../html-components/send-email/send-email.component';

@Injectable({
  providedIn: 'root'
})
export class SendEmailService {

  constructor(private modalService: NgbModal) { }

  public send(emailTo?: string)
   {
    let title = "Enviar correo";
    let btnOkText = 'Enviar';
    let btnCancelText = 'Cancelar';
    
    const modalRef = this.modalService.open(SendEmailComponent, { size: "sm" });
    modalRef.componentInstance.title = title;
    modalRef.componentInstance.emailTo = emailTo;
    modalRef.componentInstance.btnOkText = btnOkText;
    modalRef.componentInstance.btnCancelText = btnCancelText;

    return modalRef.result;
  }
}
