import { Component, OnInit } from '@angular/core';
import { TallerService } from '../../services/talleres/taller.service';
import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { Taller } from '../../services/talleres/taller';
import { PROVINCES } from '../../enums/provinces';

@Component({
  selector: 'app-taller-detail',
  templateUrl: './taller-detail.component.html',
  styleUrls: ['./taller-detail.component.scss']
})
export class TallerDetailComponent implements OnInit {

  taller: Taller;
  provinces = PROVINCES;
  // disabled: boolean;
  // mode: string;

  constructor(
    private route: ActivatedRoute,
    private tallerService: TallerService,
    private location: Location) { }

  ngOnInit(): void {
    this.getProduct();
  }

  getProduct(): void {
    const id = +this.route.snapshot.paramMap.get('id');
    this.tallerService.getTaller(id)
      .subscribe(taller => this.taller = taller);
  }

  onSubmit() {
    this.tallerService.updateTaller(this.taller).subscribe(taller => {
      this.taller = taller; this.goBack()
    });
  }

  goBack(): void {
    this.location.back();
  }

  // constructor(
  //   private route: ActivatedRoute,
  //   private tallerService: TallerService,
  //   private location: Location) { }

  // ngOnInit(): void {
  //   this.identifyMode();
  // }

  // private identifyMode() {
  //   if (this.isNewMode()) {
  //     this.preloadNewMode();
  //   } else {
  //     if (this.isEditMode()) {
  //       this.preloadEditMode();
  //     } else {
  //       this.preloadViewMode();
  //     }
  //   }
  // }

  // private isNewMode() {
  //   return isNaN(this.route.snapshot.params.id);
  // }

  // private preloadNewMode() {
  //   this.taller = new Taller();
  //   this.disabled = false;
  //   this.mode = "new";
  // }

  // private isEditMode() {
  //   return this.route.snapshot.routeConfig.path == "talleres/:id/edit";
  // }
  // private preloadEditMode() {
  //   this.disabled = false;
  //   this.mode = "edit";
  //   this.getTallerInfo();
  // }

  // private preloadViewMode() {
  //   this.disabled = true;
  //   this.mode = "view";
  //   this.getTallerInfo();
  // }
  // private getTallerInfo() {
  //   const id = +this.route.snapshot.paramMap.get('id');
  //   this.tallerService.getTaller(id)
  //     .subscribe(taller => this.taller = taller);
  // }

  // onSubmit() {
  //   if (this.mode == "edit") {
  //     this.tallerService.updateTaller(this.taller).subscribe(taller => this.taller = taller);
  //   } else {
  //     this.tallerService.addTaller(this.taller).subscribe(taller => this.taller = taller);
  //   }
  //   this.goBack();
  // }

  // goBack(): void {
  //   this.location.back();
  // }

}
