import { Component, OnInit } from '@angular/core';
import { Taller } from 'src/app/services/talleres/taller';
import { TallerService } from 'src/app/services/talleres/taller.service';
import { Location } from '@angular/common';
import { PROVINCES } from '../../enums/provinces';

@Component({
  selector: 'app-taller-form',
  templateUrl: './taller-form.component.html',
  styleUrls: ['./taller-form.component.scss']
})
export class TallerFormComponent implements OnInit {

  model = new Taller();
  provinces = PROVINCES;
  
  constructor(
    public tallerService: TallerService,
    private location: Location
  ) { }

  onSubmit() { 
    this.tallerService.addTaller(this.model).subscribe(taller => this.model = taller);
    this.goBack();
  }

  ngOnInit(): void {
  }

  goBack(): void {
    this.location.back();
  }

}
