import { Component, OnInit } from '@angular/core';
import { Taller } from '../services/talleres/taller';
import { TallerService } from '../services/talleres/taller.service';
import { OrderService } from '../services/util/order.service';

@Component({
  selector: 'app-talleres',
  templateUrl: './talleres.component.html',
  styleUrls: ['./talleres.component.scss']
})
export class TalleresComponent implements OnInit {

  tallerList: Taller[];
  order: string;

  constructor(
    private tallerService: TallerService,
    private orderService: OrderService) { }

  ngOnInit() {
    this.getTalleres();
  }

  getTalleres(): void {
    this.tallerService.getTalleres()
      .subscribe(talleres => this.tallerList = talleres);
  }

  sort(property: string) {
    let tempOrder: string;
    this.order == "desc" ? tempOrder = "asc" : tempOrder = "desc";
    this.tallerList.sort(this.orderService.compareValues(property, tempOrder));
    this.order = tempOrder;
  }
}
