import { Component, OnInit } from '@angular/core';
import { Location } from '@angular/common';

import { Vehicle } from '../../services/vehicles/vehicle';
import { VehicleService } from '../../services/vehicles/vehicle.service';
import { Client } from '../../services/clients/client';
import { ClientService } from '../../services/clients/client.service';
import { ActivatedRoute } from '@angular/router';
import { map } from 'rxjs/operators';

@Component({
  selector: 'app-vehicle-form',
  templateUrl: './vehicle-form.component.html',
  styleUrls: ['./vehicle-form.component.scss']
})
export class VehicleFormComponent implements OnInit {

  clientList: Client[];
  model = new Vehicle();

  constructor(
    public vehicleService: VehicleService,
    public clientService: ClientService,
    private location: Location,
    public activatedRoute: ActivatedRoute
  ) {
    this.clientService.getClients().subscribe(clients => this.clientList = clients);
  }

  ngOnInit() {
    //this.tallerService.getTalleres().subscribe(talleres => this.tallerList = talleres);
    this.activatedRoute.paramMap
      .pipe(map(() => window.history.state))
      .subscribe(data => {
        this.model.plate = data.plate;
      });
  }

  onSubmit() {
    this.vehicleService.addVehicle(this.model).subscribe(vehicle => this.model = vehicle);
    this.goBack();
  }

  goBack(): void {
    this.location.back();
  }

}
